=== src/backend/utils/resowner/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile--
#    Makefile for utils/resowner
#
# IDENTIFICATION
#    src/backend/utils/resowner/Makefile
#
#-------------------------------------------------------------------------

subdir = src/backend/utils/resowner
top_builddir = ../../../..
include $(top_builddir)/src/Makefile.global

OBJS = resowner.o

include $(top_srcdir)/src/backend/common.mk
