=== debian/changelog ===
postgresql-9.4 (9.4.26-0+deb8u1) jessie-security; urgency=medium

  * New upstream version.
    + Add missing permissions checks for ALTER ... DEPENDS ON EXTENSION.

      Marking an object as dependent on an extension did not have any
      privilege check whatsoever.  This oversight allowed any user to mark
      routines, triggers, materialized views, or indexes as droppable by
      anyone able to drop an extension.  Require that the calling user own the
      specified object (and hence have privilege to drop it). (CVE-2020-1720)

  * This is the last release of the 9.4 series. Please upgrade to a newer
    PostgreSQL major version.

 -- Christoph Berg <myon@debian.org>  Tue, 11 Feb 2020 15:03:00 +0100

postgresql-9.4 (9.4.25-0+deb8u1) jessie-security; urgency=medium

  * New upstream version. This is the next-to-last release of the 9.4 series.
    Please upgrade to a newer PostgreSQL major version.
  * Register debconf templates in postinst. (Closes: #935759)

 -- Christoph Berg <myon@debian.org>  Mon, 18 Nov 2019 11:49:49 +0100

postgresql-9.4 (9.4.24-0+deb8u1) jessie-security; urgency=medium

  * New upstream security release.
    + Fixes regression in ALTER TABLE on multiple columns. (Closes: #932247)

    + Require schema qualification to cast to a temporary type when using
      functional cast syntax (Noah Misch)

      We have long required invocations of temporary functions to explicitly
      specify the temporary schema, that is pg_temp.func_name(args). Require
      this as well for casting to temporary types using functional notation,
      for example pg_temp.type_name(arg). Otherwise it's possible to capture a
      function call using a temporary object, allowing privilege escalation in
      much the same ways that we blocked in CVE-2007-2138. (CVE-2019-10208)

  * Move maintainer address to tracker.
  * On purge, ask the user if they want to remove clusters.
    (Closes: #911940, #933368)

 -- Christoph Berg <myon@debian.org>  Thu, 08 Aug 2019 16:53:00 +0200

postgresql-9.4 (9.4.22-0+deb8u1) jessie-security; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Thu, 09 May 2019 10:04:31 +0200

postgresql-9.4 (9.4.21-0+deb8u1) jessie-security; urgency=medium

  * New upstream version.
  * Revert upstream patch "Disallow setting client_min_messages higher than
    ERROR", it causes to much disruption to existing (test) scripts.

 -- Christoph Berg <christoph.berg@credativ.de>  Mon, 18 Feb 2019 12:00:44 +0100

postgresql-9.4 (9.4.20-0+deb8u1) jessie-security; urgency=medium

  * New upstream version.

 -- Christoph Berg <christoph.berg@credativ.de>  Fri, 25 Jan 2019 09:12:38 +0100

postgresql-9.4 (9.4.19-0+deb8u1) jessie-security; urgency=medium

  * New upstream version.
    + Fix failure to reset libpq's state fully between connection attempts

      An unprivileged user of dblink or postgres_fdw could bypass the checks
      intended to prevent use of server-side credentials, such as a ~/.pgpass
      file owned by the operating-system user running the server.  Servers
      allowing peer authentication on local connections are particularly
      vulnerable.  Other attacks such as SQL injection into a postgres_fdw
      session are also possible. Attacking postgres_fdw in this way requires
      the ability to create a foreign server object with selected connection
      parameters, but any user with access to dblink could exploit the
      problem. In general, an attacker with the ability to select the
      connection parameters for a libpq-using application could cause
      mischief, though other plausible attack scenarios are harder to think
      of. Our thanks to Andrew Krasichkov for reporting this issue.
      (CVE-2018-10915)

  * Add new pgtypes header and symbol.

 -- Christoph Berg <christoph.berg@credativ.de>  Mon, 06 Aug 2018 16:14:28 +0200

postgresql-9.4 (9.4.18-0+deb8u1) jessie; urgency=medium

  * New upstream version.
    + Fix incorrect volatility markings on a few built-in functions.

 -- Christoph Berg <myon@debian.org>  Tue, 08 May 2018 20:37:04 +0200
