=== debian/watch ===
version=3
opts=uversionmangle=s/alpha/~alpha/;s/beta/~beta/;s/rc/~rc/ \
ftp://ftp.postgresql.org/pub/source/v(9.4.*)/postgresql-(9.4.*).tar.bz2
